#!/usr/bin/env python3
numsides = 6
maxa = 4
maxd = 3

def aloss(avec, dvec) :
    avec.sort(reverse=True)
    dvec.sort(reverse=True)

    loss=0
    for pair in zip(avec, dvec) :
        if pair[0]<=pair[1] : loss+=1

    return loss

def main() :
    cnt = (min(maxa, maxd)+ 1)*[0]

    for a1 in range(numsides) :
        for a2 in range(numsides) :
            for a3 in range(numsides) :
                for a4 in range(numsides) :
                    avec = [a1, a2, a3, a4]
                    for d1 in range(numsides) :
                        for d2 in range(numsides) :
                            for d3 in range(numsides) :
                                dvec = [d1, d2, d3]
                                cnt[aloss(avec[:maxa], dvec[:maxd])]+=1
    print("Attacker Loss Table A:{} D:{} for {} sided die".format(maxa, maxd, numsides))
    print("Loss", "Probability")
    denom = numsides**7
    for i in range(0, len(cnt)) :
        print("{:4} {}/{} {:3.1f}%".format(i, cnt[i], denom, cnt[i]/denom*100))


main()                                

