#!/usr/bin/env python3
import sys

fibtab = {}
def fib(n) :
    """compute the nth Fibonacci number using a cache"""
    if n in fibtab :
        return fibtab[n]
    if (n==1 or n==2) :
       return 1
    else :
       ans = fib(n-1) + fib(n-2)       
       fibtab[n] = ans
       return ans

def main() :
    while True :
        n = int(sys.stdin.readline())
        if (n<1) : break
        print(n, fib(n))
#    print(fibtab.keys())

main()
